File: get.sh
   1 #!/bin/sh
   2 
   3 # The MIT License (MIT)
   4 #
   5 # Copyright © 2024 pacman64
   6 #
   7 # Permission is hereby granted, free of charge, to any person obtaining a copy
   8 # of this software and associated documentation files (the “Software”), to deal
   9 # in the Software without restriction, including without limitation the rights
  10 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  11 # copies of the Software, and to permit persons to whom the Software is
  12 # furnished to do so, subject to the following conditions:
  13 #
  14 # The above copyright notice and this permission notice shall be included in
  15 # all copies or substantial portions of the Software.
  16 #
  17 # THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  18 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  19 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  20 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  21 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  22 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  23 # SOFTWARE.
  24 
  25 
  26 # get [options...] [filepaths/URIs/data-URIs...]
  27 #
  28 # Get data from the named source given, whether this is a filename, a URI,
  29 # or even a base64-encoded data-URI. Data-URIs are simply decoded into the
  30 # bytes they represent, no loading/fetching required.
  31 #
  32 # The only options show this help message, via any of `-h`, `--h`, `-help`,
  33 # or `--help`.
  34 
  35 
  36 # set -o pipefail
  37 
  38 
  39 # fail quits the script right after showing the message given, using
  40 # exit code given as its 2nd arg
  41 fail() {
  42     printf "\e[31m%s\e[0m\n" "$1" > /dev/stderr
  43     exit "${2:-1}"
  44 }
  45 
  46 
  47 if [ $# -eq 0 ]; then
  48     cat
  49     exit $?
  50 fi
  51 
  52 dashes=0
  53 for name in "${@:--}"; do
  54     if [ "${name}" = "-" ]; then
  55         dashes="$((dashes + 1))"
  56     fi
  57 
  58     if [ "${dashes}" -gt 1 ]; then
  59         printf "\e[31mcan't use dash/stdin multiple times\e[0m\n" > /dev/stderr
  60         exit 1
  61     fi
  62 done
  63 
  64 for name in "${@:--}"; do
  65     if [ -z "${name}" ]; then
  66         continue
  67     fi
  68 
  69     # if the argument given is an existing file, just use `cat`, even if the
  70     # name looks like a protocol presumably meant for `curl`
  71     if [ -e "${name}" ]; then
  72         cat "${name}" || fail "failed to read file '${name}'" $?
  73         continue
  74     fi
  75 
  76     case "${name}" in
  77         -h|--h|-help|--help)
  78             awk '/^# +get/, /^$/ { gsub(/^# ?/, ""); print }' "$0"
  79             exit 0
  80         ;;
  81 
  82         # http://*|https://*|ftp://*) wget -O - "${name}";;
  83 
  84         http://*|https://*|ftp://*)
  85             # handle the commonest kinds of URIs
  86             curl -s -L "${name}" || fail "failed to fetch URI '${name}'" $?
  87         ;;
  88 
  89         dict://*|ftps://*|gopher://*|gophers://*|rtmp://*|rtsp://*|scp://*|\
  90         sftp://*|smb://*|smbs://*|telnet://*|tftp://*)
  91             # handle more kinds of URIs
  92             curl -s -L "${name}" || fail "failed to fetch URI '${name}'" $?
  93         ;;
  94 
  95         data:*)
  96             # handle data-URIs
  97             { echo "${name}" | sed 's-^.{0,64},--1' | base64 -d; } || \
  98                 fail "failed to decode data-URI '${name}'" $?
  99         ;;
 100 
 101         file://*)
 102             # handle files
 103             cat "$(echo "${name}" | sed 's-^file://--')" 2> /dev/null || \
 104                 fail "failed to open file '${name}'" $?
 105         ;;
 106 
 107         -)
 108             # handle standard input
 109             cat "${name}" 2> /dev/null || \
 110                 fail "failed to read from the standard input" $?
 111         ;;
 112 
 113         *)
 114             # handle files
 115             cat "${name}" 2> /dev/null || \
 116                 fail "failed to open file '${name}'" $?
 117         ;;
 118     esac
 119 done